#include <AccelStepper.h> //vordefinierte Bibliothek

//#define DEBUG

//TO-DO: Programm auf alle Achsen duplizieren, Inkrementalgeber, max. Wertebereich anfahren, bei Programmstart Nullpunkt einstellen: Lichtschranke?

AccelStepper stepper(1,4,3); //1=Treiberboard(definiert), Schritt, Richtung 
int EndschalterPinlinks = 22; // Eingang 22 für Kontakt links
int EndschalterPinrechts = 23; // Eingang 23 für Kontakt rechts
int sollweg = 0; // sollweg in mm
int zielweg = 0;
int Vorzeichen = 1;      //wird bei der ASCII Umwandlung benötigt
double Schritt = 0.033; //Verhältnis, um absolute Distanzen anzufahren 
                       //66/200 = 0,33 (Übersetzung = 66 mm/Umdrehung -> ZLW/-OD-1040Basic Datenblatt, 
                      //200 = Auflösung bei 1,8° Schrittwinkel)
                     //Gecko: Verhältnis 1 zu 10 --> 0,033

double Verfahr = 0; //Zuordnen des Verfahrweg --> Verfahr = Anzahl der Schritte für den gewünschten Weg

//vorwärts fahren = 1, rückwärts fahren = 0 --> Directionsignal, wird automatisch im Programm umgesetzt

void setup()
 {
         Serial.begin(9600);                    // Port für serielle Kommunikation auf 9600 baud Rate Übertragungsgeschwindigkeit setzen  
         stepper.setAcceleration(24000000);   // Beschleunigung,Geschwindigkeit --> Frequenzänderung
         stepper.setCurrentPosition(0);     // Referenzposition = 0 setzen   
         pinMode(EndschalterPinlinks,  INPUT); 
         pinMode(EndschalterPinrechts, INPUT);    
         Serial.println("Initialisierung abgeschlossen");  
 }
 
 void loop()
 {              
     if(Serial.available()>0)   //Koordinaten einlesen 
         {
           char ascii = Serial.read();
           #ifdef DEBUG 
                Serial.println(ascii, DEC);
           #endif 
           if (ascii == '-') //feststellen, ob Minusvorzeichen gesetzt wurde
           {
             Vorzeichen = -1;
           }
           
           if(isDigit (ascii)) //Prüfen, ob ASCII-Zeichen zw. 0 und 9 liegt (Dezimalzahlen 48 bis 57)
           {
            
             #ifdef DEBUG
                Serial.println(sollweg*10);
                Serial.println(ascii-'0');
             #endif  
             zielweg = (zielweg*10) + (ascii - '0');    //der ASCII Wert 48 entspricht der 0 (Synonym: 'ascii - 48')
                                                      //--> es wird aus dem ASCII Wert der Variablen ein Dezimalwert gebildet
                                                     //die Multiplikation mit 10 erfolgt nach jeder zusätzlich eingegeben Zeichen in einer Zeile,
                                                    //um so auch mehrstellige Dezimalzahlen darstellen zu können
                                                   //eine Zahleneingabe endet mit dem NewLine Befehl, dieser entspricht dem ASCII-Code '10'
             #ifdef DEBUG
                Serial.println("Zielwegberechnung..");
                Serial.println(zielweg, DEC);
             #endif
           }
          
           else if(ascii == 10 ) //feststellen, ob Zahleneingabe komplett, d.h NewLine Befehl (ASCII=10)
           {
            #ifdef DEBUG
             Serial.println(sollweg);
            #endif
            zielweg = zielweg*Vorzeichen; //Wert mit Vorzeichen multiplizieren
            Serial.print("Bekommener Wert: ");
            Serial.println(zielweg, DEC);
            sollweg = zielweg;
            zielweg = 0;
            Vorzeichen = 1;
           }
          }      
         
     if (digitalRead(EndschalterPinlinks) == LOW && digitalRead(EndschalterPinrechts) == LOW) //Sicherheitsabfrage
       {
         Verfahr = sollweg/Schritt;  //Umrechnen des eingegebenen Koordinatenwertes in Anzahl von Schritten
         stepper.moveTo(Verfahr);   //Festlegen des Weges
	 Verfahren();              //Unterprogramm Verfahren() ausführen
       }
       
     else if(digitalRead(EndschalterPinlinks) == HIGH) //wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_links");
          stepper.move(500);
          int diff =  stepper.currentPosition() + 500;         
          while(stepper.currentPosition() != diff)
          {
            stepper.run();
          }
            sollweg = stepper.currentPosition()*Schritt;
        } 
          
     else if(digitalRead(EndschalterPinrechts) == HIGH)//wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_rechts");
          stepper.move(-500); 
          int diff =  stepper.currentPosition() - 500;         
          while(stepper.currentPosition() != diff)
          {
            stepper.run();
          }          
            sollweg = stepper.currentPosition()*Schritt;        
        }        
 }
    
   void Verfahren() 
{
		if (stepper.currentPosition() != Verfahr ) //solange bis Position erreicht "run"
                {
			stepper.run();
		}
                
        stepper.setSpeed(0);
        stepper.moveTo(stepper.currentPosition()); //Beschreiben der aktuellen Position        
} 

