#include <AccelStepper.h> //vordefinierte Bibliothek

//#define DEBUG

AccelStepper stepperx(1,9,8);   // 1=Treiberboard(definiert), Schritt, Richtung 
AccelStepper steppery(1,5,6);   // 1=Treiberboard(definiert), Schritt, Richtung 
AccelStepper stepperz(1,4,3);

int EndschalterPinlinksx = 22;  // Eingang 22 für Kontakt links
int EndschalterPinrechtsx = 23; // Eingang 23 für Kontakt rechts
int EndschalterPinlinksy = 24; 
int EndschalterPinrechtsy = 25; 
int EndschalterPinlinksz = 26; 
int EndschalterPinrechtsz = 27; 

int sollwegx = 0; // sollweg in mm
int sollwegy = 0; // sollweg in mm
int sollwegz = 0; // sollweg in mm
int zielweg = 0;

double Schritt = 0.033;  // Verhältnis, um absolute Distanzen anzufahren 
                         // 66/200 = 0,33 (Übersetzung = 66 mm/Umdrehung -> ZLW/-OD-1040Basic Datenblatt, 
                         // 200 = Auflösung bei 1,8° Schrittwinkel)
                         // Gecko: Verhältnis 1 zu 10 --> 0,033

double Verfahrx = 0;     // Zuordnen des Verfahrweg --> Verfahr = Anzahl der Schritte für den gewünschten Weg
double Verfahry = 0;
double Verfahrz = 0;

int status_x = 0;
int status_y = 0;
int status_z = 0;

char ascii;

//vorwärts fahren = 1, rückwärts fahren = 0 --> Directionsignal, wird automatisch im Programm umgesetzt

void setup()
 {
         Serial.begin(9600);                    // Port für serielle Kommunikation auf 9600 baud Rate Übertragungsgeschwindigkeit setzen  
         stepperx.setAcceleration(24000000);    // Beschleunigung,Geschwindigkeit --> Frequenzänderung
         stepperx.setCurrentPosition(0);        // Referenzposition = 0 setzen  
         steppery.setAcceleration(24000000);   
         steppery.setCurrentPosition(0);     
         stepperz.setAcceleration(24000000);   
         stepperz.setCurrentPosition(0);  
         pinMode(EndschalterPinlinksx,  INPUT); 
         pinMode(EndschalterPinrechtsx, INPUT);  
         pinMode(EndschalterPinlinksy,  INPUT); 
         pinMode(EndschalterPinrechtsy, INPUT);  
         pinMode(EndschalterPinlinksz,  INPUT); 
         pinMode(EndschalterPinrechtsz, INPUT);   
         Serial.println("Initialisierung abgeschlossen");
         Serial.flush();
 }
 
 void loop()
 {  
   if(Serial.available() > 0)   //Koordinaten einlesen 
         {
           //char ascii = Serial.read();
           ascii = Serial.read();
           
           #ifdef DEBUG
                 Serial.print("Erstes Lesen, Ascii = ");
                 Serial.println(ascii);
                 #endif
//_______________________________________________________________________________________________________        
          
           if (ascii == 'x') //feststellen, ob x gesetzt wurde
           {
             #ifdef DEBUG
             Serial.println("ascii = x");
             #endif
             status_x = 1;
             while (status_x == 1)  
              {
                  #ifdef DEBUG
                 Serial.println("umrechnen");
                 #endif
                //char ascii = Serial.read();
                status_x = UmrechnungplusBerechnung(); 
              }
             #ifdef DEBUG
                 Serial.println("X-Ende");
                 #endif 
           }
           
                     
           if (ascii == 'y')
           {
            Serial.print("Bekommener Wertx: ");
            Serial.println(zielweg, DEC);
            sollwegx = zielweg;
            zielweg = 0;    
           }
           #ifdef DEBUG
           else{
           Serial.print("ascii = ");
            Serial.println(ascii);  
           }
           #endif
// _____________________________________________________________________________________________________  
           
           if (ascii == 'y') //feststellen, ob y gesetzt wurde
           {
             #ifdef DEBUG
             Serial.println("ascii = y");
             #endif
             status_y = 1;
             while (status_y == 1)  
              {
                 #ifdef DEBUG
                 Serial.println("umrechnen");
                 #endif
         
                status_y = UmrechnungplusBerechnung(); 
              } 
              #ifdef DEBUG
                 Serial.println("Y-Ende");
                 #endif 
           }   
                 
           if (ascii == 'z')
           {
            Serial.print("Bekommener Werty: ");
            Serial.println(zielweg, DEC);
            sollwegy = zielweg;
            zielweg = 0;    
           } 
//______________________________________________________________________________________________________           
        
        if (ascii == 'z') //feststellen, ob z gesetzt wurde
           {                         
             status_z = 1;
             while (status_z == 1)  
              {
                //
                //char ascii = Serial.read();
                status_z = UmrechnungplusBerechnung(); 
              } 
           }   
        if (ascii == 'e')
           {
            Serial.print("Bekommener Wertz: ");
            Serial.println(zielweg, DEC);
            sollwegz = zielweg;
            zielweg = 0;    
           } 
      }//Ende Koordinaten einlesen          
//______________________________________________________________________________________________________     
//______________________________________________________________________________________________________

   
     if (digitalRead(EndschalterPinlinksx) == LOW && digitalRead(EndschalterPinrechtsx) == LOW) //Sicherheitsabfrage
       {
         Verfahrx = sollwegx/Schritt;  // Umrechnen des eingegebenen Koordinatenwertes in Anzahl von Schritten
         stepperx.moveTo(Verfahrx);    // Festlegen des Weges
	 Verfahrenx();                 // Unterprogramm Verfahren() ausführen
       }
       
     else if(digitalRead(EndschalterPinlinksx) == HIGH) // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_linksx");
          stepperx.move(500);
          int diff =  stepperx.currentPosition() + 500;         
          while(stepperx.currentPosition() != diff)
          {
            stepperx.run();
          }
            sollwegx = stepperx.currentPosition()*Schritt;
        } 
          
     else if(digitalRead(EndschalterPinrechtsx) == HIGH)  // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_rechtsx");
          stepperx.move(-500); 
          int diff =  stepperx.currentPosition() - 500;         
          while(stepperx.currentPosition() != diff)
          {
            stepperx.run();
          }          
            sollwegx = stepperx.currentPosition()*Schritt;        
        }
            
           
//________________________________________________________________________________________________________       
   
     
     if (digitalRead(EndschalterPinlinksy) == LOW && digitalRead(EndschalterPinrechtsy) == LOW) // Sicherheitsabfrage
       {
         Verfahry = sollwegy/Schritt;  // Umrechnen des eingegebenen Koordinatenwertes in Anzahl von Schritten
         steppery.moveTo(Verfahry);    // Festlegen des Weges
	 Verfahreny();                 // Unterprogramm Verfahren() ausführen
       }
       
     else if(digitalRead(EndschalterPinlinksy) == HIGH)   // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_linksy");
          steppery.move(500);
          int diff =  steppery.currentPosition() + 500;         
          while(steppery.currentPosition() != diff)
          {
            steppery.run();
          }
            sollwegy = steppery.currentPosition()*Schritt;
        } 
          
     else if(digitalRead(EndschalterPinrechtsy) == HIGH)   // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_rechtsy");
          steppery.move(-500); 
          int diff =  steppery.currentPosition() - 500;         
          while(steppery.currentPosition() != diff)
          {
            steppery.run();
          }          
            sollwegy = steppery.currentPosition()*Schritt;        
        }     
            
//______________________________________________________________________________________________________ 
    
     
     if (digitalRead(EndschalterPinlinksz) == LOW && digitalRead(EndschalterPinrechtsz) == LOW) //Sicherheitsabfrage
       {
         Verfahrz = sollwegz/Schritt;    // Umrechnen des eingegebenen Koordinatenwertes in Anzahl von Schritten
         stepperz.moveTo(Verfahrz);      // Festlegen des Weges
	 Verfahrenz();                   // Unterprogramm Verfahren() ausführen
       }
       
     else if(digitalRead(EndschalterPinlinksz) == HIGH) // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_linksz");
          stepperz.move(500);
          int diff =  stepperz.currentPosition() + 500;         
          while(stepperz.currentPosition() != diff)
          {
            stepperz.run();
          }
            sollwegz = stepperz.currentPosition()*Schritt;
        } 
          
     else if(digitalRead(EndschalterPinrechtsz) == HIGH) // wenn Schalter belegt - rückfahren
        { 
          Serial.println("Endschalter_rechtsz");
          stepperz.move(-500); 
          int diff =  stepperz.currentPosition() - 500;         
          while(stepperz.currentPosition() != diff)
          {
            stepperz.run();
          }          
            sollwegz = stepperz.currentPosition()*Schritt;        
        }     
 }
   
//__________________________________________________________________________________________________________ 
//__________________________________________________________________________________________________________   
   
      void Verfahrenx() 
{
		if (stepperx.currentPosition() != Verfahrx ) //solange bis Position erreicht "run"
                {
			stepperx.run();
		}
                
        stepperx.setSpeed(0);
        stepperx.moveTo(stepperx.currentPosition()); //Beschreiben der aktuellen Position        
} 

//__________________________________________________________________________________________________________

   void Verfahreny() 
{
		if (steppery.currentPosition() != Verfahry ) //solange bis Position erreicht "run"
                {
			steppery.run();
		}
                
        steppery.setSpeed(0);
        steppery.moveTo(steppery.currentPosition()); //Beschreiben der aktuellen Position        
} 

//_________________________________________________________________________________________________________

   void Verfahrenz() 
{
		if (stepperz.currentPosition() != Verfahrz ) //solange bis Position erreicht "run"
                {
			stepperz.run();
		}
                
        stepperz.setSpeed(0);
        stepperz.moveTo(stepperz.currentPosition()); //Beschreiben der aktuellen Position        
} 

//________________________________________________________________________________________________________
//________________________________________________________________________________________________________

  int UmrechnungplusBerechnung()
 {
     //char ascii;
         #ifdef DEBUG
         Serial.print("Ascii vor dem Lesen: ");
         Serial.println(ascii);
         #endif
      ascii = Serial.read();
         #ifdef DEBUG
         Serial.print("Ascii nach dem Lesen: ");
         Serial.println(ascii);
         #endif
           if(isDigit(ascii))   // Prüfen, ob ASCII-Zeichen zw. 0 und 9 liegt (Dezimalzahlen 48 bis 57)
           {
            
            
                     zielweg = (zielweg*10) + (ascii - '0');    // der ASCII Wert 48 entspricht der 0 (Synonym: 'ascii - 48')
                                                                //  --> es wird aus dem ASCII Wert der Variablen ein Dezimalwert gebildet
                                                                // die Multiplikation mit 10 erfolgt nach jeder zusÃ¤tzlich eingegeben Zeichen in einer Zeile,
                                                                // um so auch mehrstellige Dezimalzahlen darstellen zu können
                                                                // eine Zahleneingabe endet mit dem NewLine Befehl, dieser entspricht dem ASCII-Code '10'
                                                           
                     #ifdef DEBUG
                     Serial.print("Zielweg: ");
                     Serial.println(zielweg);
                     #endif
                     return 1;
           }
           else 
           {
             #ifdef DEBUG
             Serial.print(ascii);
             Serial.println(" is Not Digit");
             #endif
            return 0;
           }
 } 
//_______________________________________________________________________________________________________  
             

